package org.jboss.repro.stateful.timeout.http;

import org.jboss.repro.stateful.timeout.StatefulTimeoutManagerRemote;

import javax.ejb.EJB;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

@WebServlet(name = "leak",
    loadOnStartup = 1,
    urlPatterns = {"/leak", "/noleak"})
public class StatefulServlet extends HttpServlet {
  @EJB
  private StatefulTimeoutManagerRemote manager;

  @Override
  protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
    final String uri = req.getRequestURI();

    if (uri.endsWith("/leak")) {
      manager.leak();
    } else if (uri.endsWith("/noleak")) {
      manager.noLeak();
    } else {
      resp.setStatus(HttpServletResponse.SC_NOT_FOUND);
      return;
    }

    resp.setStatus(HttpServletResponse.SC_OK);
  }
}
